From bcb0015c78dbf18d5d5efab2d328e941704eec3e Mon Sep 17 00:00:00 2001
From: Devyani Kota <divs.passion.18@gmail.com>
Date: Mar 14 2016 18:22:07 +0000
Subject: [PATCH 319/1001] Fixed issue #10: Added Subscribed_to stats and Subscribe/Unsubscribe button


---

diff --git a/hubs/models.py b/hubs/models.py
index 2b94422..0696266 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -125,6 +125,7 @@ class Hub(BASE):
     summary = sa.Column(sa.String(128))
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
     widgets = relation('Widget', backref=backref('hub'))
+    users = relation('Association', backref=backref('hubs'))
     left_width = sa.Column(sa.Integer, nullable=False, default=8)
     archived = sa.Column(sa.Boolean, default=False)
     user_hub = sa.Column(sa.Boolean, default=False)
@@ -306,6 +307,7 @@ class User(BASE):
     openid = sa.Column(sa.Text, primary_key=True)
     fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
+    hubs = relation('Association', backref=backref('users'))
 
     def __json__(self, session):
         return {
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index b81a2cd..5ff412f 100644
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -3,6 +3,7 @@ from hubs.widgets.chrome import panel
 
 from hubs.utils import commas
 
+import flask
 import jinja2
 import requests
 
@@ -16,13 +17,21 @@ template = jinja2.Template("""
 <div class="stats-container row">
   <div class="col-sm-7 col-md-12 col-lg-7">
   <table class="stats-table">
-    <tr><th>FedMsgs</th><th>Subscribers</th></tr>
-    <tr class="text-info"><td>{{fedmsgs_text}}</td><td class="text-right">{{subscribers_text}}</td></tr>
+    <tr><th>subscribers</th><th>Subscribed_to</th></tr>
+    <tr class="text-info"><td>{{subscribers_text}}</td><td class="text-center">{{subscribed_text}}</td></tr>
   </table>
   </div>
   <div class="col-sm-5 col-md-12 col-lg-5">
   {% if session['nickname'] != username %}
-  <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+    {% if session['nickname'] in subscribers %}
+    <li><form action="{{hub_unsubscribe_url}}" method="POST">
+        <button class="btn btn-info"><span class="glyphicon glyphicon-remove-sign" aria-hidden="true"></span> Unsubscribe</button>
+    </form></li>
+    {% else %}
+    <li><form action="{{hub_subscribe_url}}" method="POST">
+        <button class="btn btn-default"><span class="glyphicon glyphicon-plus" aria-hidden="true"></span> Subscribe</button>
+    </form></li>
+    {% endif %}
   {% endif %}
   </div>
 </div>
@@ -34,12 +43,19 @@ def data(session, widget, username):
     url = url.format(username=username)
     response = requests.get(url)
     fedmsgs = response.json()['total']
+    for assoc in widget.hub.users:
+        sub_list = [u.name for u in assoc.user.subscriptions]
+    subscribers = [u.username for u in widget.hub.subscribers]
     return dict(
         username=username,
         fedmsgs=fedmsgs,
-        subscribers=len(widget.hub.subscribers),
+        subscribers=subscribers,
+        subscribed_to=sub_list,
         fedmsgs_text=commas(fedmsgs),
-        subscribers_text=commas(len(widget.hub.subscribers)),
+        subscribers_text=commas(len(subscribers)),
+        subscribed_text=commas(len(sub_list)),
+        hub_subscribe_url=flask.url_for('hub_subscribe', hub=widget.hub.name),
+        hub_unsubscribe_url=flask.url_for('hub_unsubscribe', hub=widget.hub.name),
     )
 
 

